diff --git a/testing/mozbase/mozcrash/tests/test.py b/testing/mozbase/mozcrash/tests/test.py
index 8f6b14f50b..1d71684dbb 100644
--- a/testing/mozbase/mozcrash/tests/test.py
+++ b/testing/mozbase/mozcrash/tests/test.py
@@ -9,7 +9,7 @@ import unittest
 import subprocess
 import tempfile
 import shutil
-import urlparse
+import six.moves.urllib.parse
 import zipfile
 import StringIO
 import mozcrash
@@ -25,17 +25,17 @@ def popen_factory(stdouts):
     Generate a class that can mock subprocess.Popen. |stdouts| is an iterable that
     should return an iterable for the stdout of each process in turn.
     """
-    class mock_popen(object):
+    class mock_popen:
 
         def __init__(self, args, *args_rest, **kwargs):
-            self.stdout = stdouts.next()
+            self.stdout = next(stdouts)
             self.returncode = 0
 
         def wait(self):
             return 0
 
         def communicate(self):
-            return (self.stdout.next(), "")
+            return (next(self.stdout), "")
 
     return mock_popen
 
@@ -77,7 +77,7 @@ class TestCrash(unittest.TestCase):
         """
         open(os.path.join(self.tempdir, "test.dmp"), "w").write("foo")
         self.stdouts.append(["this is some output"])
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path='symbols_path',
                                                 stackwalk_binary=self.stackwalk,
                                                 quiet=True))
@@ -89,7 +89,7 @@ class TestCrash(unittest.TestCase):
         open(os.path.join(self.tempdir, "test.dmp"), "w").write("foo")
         self.stdouts.append(["this is some output"])
         os.environ['MINIDUMP_STACKWALK'] = self.stackwalk
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path='symbols_path',
                                                 quiet=True))
         del os.environ['MINIDUMP_STACKWALK']
@@ -103,13 +103,13 @@ class TestCrash(unittest.TestCase):
         save_path = os.path.join(self.tempdir, "saved")
         os.mkdir(save_path)
         self.stdouts.append(["this is some output"])
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path='symbols_path',
                                                 stackwalk_binary=self.stackwalk,
                                                 dump_save_path=save_path,
                                                 quiet=True))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.dmp")))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.extra")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.dmp")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.extra")))
 
     def test_save_path_not_present(self):
         """
@@ -119,13 +119,13 @@ class TestCrash(unittest.TestCase):
         open(os.path.join(self.tempdir, "test.extra"), "w").write("bar")
         save_path = os.path.join(self.tempdir, "saved")
         self.stdouts.append(["this is some output"])
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path='symbols_path',
                                                 stackwalk_binary=self.stackwalk,
                                                 dump_save_path=save_path,
                                                 quiet=True))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.dmp")))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.extra")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.dmp")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.extra")))
 
     def test_save_path_isfile(self):
         """
@@ -137,13 +137,13 @@ class TestCrash(unittest.TestCase):
         save_path = os.path.join(self.tempdir, "saved")
         open(save_path, "w").write("junk")
         self.stdouts.append(["this is some output"])
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path='symbols_path',
                                                 stackwalk_binary=self.stackwalk,
                                                 dump_save_path=save_path,
                                                 quiet=True))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.dmp")))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.extra")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.dmp")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.extra")))
 
     def test_save_path_envvar(self):
         """
@@ -155,18 +155,18 @@ class TestCrash(unittest.TestCase):
         os.mkdir(save_path)
         self.stdouts.append(["this is some output"])
         os.environ['MINIDUMP_SAVE_PATH'] = save_path
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path='symbols_path',
                                                 stackwalk_binary=self.stackwalk,
                                                 quiet=True))
         del os.environ['MINIDUMP_SAVE_PATH']
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.dmp")))
-        self.assert_(os.path.isfile(os.path.join(save_path, "test.extra")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.dmp")))
+        self.assertTrue(os.path.isfile(os.path.join(save_path, "test.extra")))
 
     def test_symbol_path_not_present(self):
         open(os.path.join(self.tempdir, "test.dmp"), "w").write("foo")
         self.stdouts.append(["this is some output"])
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbols_path=None,
                                                 stackwalk_binary=self.stackwalk,
                                                 quiet=True))
@@ -193,9 +193,9 @@ class TestCrash(unittest.TestCase):
                                                 'path': '/symbols',
                                                 'function': get_symbols}])
         httpd.start()
-        symbol_url = urlparse.urlunsplit(('http', '%s:%d' % httpd.httpd.server_address,
+        symbol_url = six.moves.urllib.parse.urlunsplit(('http', '%s:%d' % httpd.httpd.server_address,
                                           '/symbols', '', ''))
-        self.assert_(mozcrash.check_for_crashes(self.tempdir,
+        self.assertTrue(mozcrash.check_for_crashes(self.tempdir,
                                                 symbol_url,
                                                 stackwalk_binary=self.stackwalk,
                                                 quiet=True))
@@ -217,7 +217,7 @@ class TestJavaException(unittest.TestCase):
         """
         Test for an exception which should be caught
         """
-        self.assert_(mozcrash.check_for_java_exception(self.test_log, quiet=True))
+        self.assertTrue(mozcrash.check_for_java_exception(self.test_log, quiet=True))
 
     def test_truncated_exception(self):
         """
@@ -226,7 +226,7 @@ class TestJavaException(unittest.TestCase):
         """
         truncated_log = list(self.test_log)
         truncated_log[0], truncated_log[1] = truncated_log[1], truncated_log[0]
-        self.assert_(mozcrash.check_for_java_exception(truncated_log, quiet=True))
+        self.assertTrue(mozcrash.check_for_java_exception(truncated_log, quiet=True))
 
     def test_unchecked_exception(self):
         """
@@ -235,7 +235,7 @@ class TestJavaException(unittest.TestCase):
         passable_log = list(self.test_log)
         passable_log[0] = "01-30 20:15:41.937 E/GeckoAppShell( 1703):" \
                           " >>> NOT-SO-BAD EXCEPTION FROM THREAD 9 (\"GeckoBackgroundThread\")"
-        self.assert_(not mozcrash.check_for_java_exception(passable_log, quiet=True))
+        self.assertTrue(not mozcrash.check_for_java_exception(passable_log, quiet=True))
 
 if __name__ == '__main__':
     unittest.main()
diff --git a/testing/mozbase/mozdebug/mozdebug/__init__.py b/testing/mozbase/mozdebug/mozdebug/__init__.py
index 3450d755c7..63e9bd6140 100644
--- a/testing/mozbase/mozdebug/mozdebug/__init__.py
+++ b/testing/mozbase/mozdebug/mozdebug/__init__.py
@@ -28,4 +28,4 @@ debugger-specific arguments:
 
 """
 
-from mozdebug import *
+from .mozdebug import *
diff --git a/testing/mozbase/mozdebug/mozdebug/mozdebug.py b/testing/mozbase/mozdebug/mozdebug/mozdebug.py
index 6dd9e9fddd..8c6e9fbcc0 100755
--- a/testing/mozbase/mozdebug/mozdebug/mozdebug.py
+++ b/testing/mozbase/mozdebug/mozdebug/mozdebug.py
@@ -4,6 +4,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os
 import mozinfo
 from collections import namedtuple
@@ -163,7 +164,7 @@ def get_debugger_info(debugger, debuggerArgs=None, debuggerInteractive=False):
                 debuggerPath = debugger
 
     if not debuggerPath:
-        print 'Error: Could not find debugger %s.' % debugger
+        print(('Error: Could not find debugger %s.' % debugger))
         return None
 
     debuggerName = os.path.basename(debuggerPath).lower()
diff --git a/testing/mozbase/mozdevice/adb_tests/test_device_running_adb_as_root.py b/testing/mozbase/mozdevice/adb_tests/test_device_running_adb_as_root.py
index 2b223bb044..f871a0c3ed 100644
--- a/testing/mozbase/mozdevice/adb_tests/test_device_running_adb_as_root.py
+++ b/testing/mozbase/mozdevice/adb_tests/test_device_running_adb_as_root.py
@@ -5,6 +5,7 @@
  Running this test case requires various reboots which makes it a
  very slow test case to run.
 """
+from __future__ import print_function
 import unittest
 import sys
 
@@ -36,13 +37,13 @@ class TestFileOperations(unittest.TestCase):
 if __name__ == "__main__":
     dm = DeviceManagerADB()
     if not dm.devices():
-        print "There are no connected adb devices"
+        print("There are no connected adb devices")
         sys.exit(1)
     else:
         if not (int(dm._runCmd(["shell", "getprop", "ro.secure"]).output[0]) and
                 int(dm._runCmd(["shell", "getprop", "ro.debuggable"]).output[0])):
-            print "This test case is meant for devices with devices that start " \
-                "adbd as non-root and allows for adbd to be restarted as root."
+            print("This test case is meant for devices with devices that start " \
+                "adbd as non-root and allows for adbd to be restarted as root.")
             sys.exit(1)
 
     unittest.main()
diff --git a/testing/mozbase/mozdevice/adb_tests/test_devicemanagerADB.py b/testing/mozbase/mozdevice/adb_tests/test_devicemanagerADB.py
index 495e449a4a..c85ccee7f9 100644
--- a/testing/mozbase/mozdevice/adb_tests/test_devicemanagerADB.py
+++ b/testing/mozbase/mozdevice/adb_tests/test_devicemanagerADB.py
@@ -34,6 +34,7 @@
  - uninstallAppAndReboot()
 """
 
+from __future__ import print_function
 import os
 import re
 import socket
@@ -207,13 +208,13 @@ class TestOther(DeviceManagerADBTestCase):
 if __name__ == '__main__':
     dm = DeviceManagerADB()
     if not dm.devices():
-        print "There are no connected adb devices"
+        print("There are no connected adb devices")
         sys.exit(1)
 
     if find_mount_permissions(dm, "/system") == "rw":
-        print "We've found out that /system is mounted as 'rw'. This is because the command " \
+        print("We've found out that /system is mounted as 'rw'. This is because the command " \
             "'adb remount' has been run before running this test case. Please reboot the device " \
-            "and try again."
+            "and try again.")
         sys.exit(1)
 
     unittest.main()
diff --git a/testing/mozbase/mozdevice/mozdevice/Zeroconf.py b/testing/mozbase/mozdevice/mozdevice/Zeroconf.py
index 54a5d53598..a709f5b290 100755
--- a/testing/mozbase/mozdevice/mozdevice/Zeroconf.py
+++ b/testing/mozbase/mozdevice/mozdevice/Zeroconf.py
@@ -74,6 +74,8 @@
                  ensure names end in '.local.'
                  timeout on receiving socket for clean shutdown"""
 
+from __future__ import print_function
+from functools import reduce
 __author__ = "Paul Scott-Murphy"
 __email__ = "paul at scott dash murphy dot com"
 __version__ = "0.12"
@@ -819,7 +821,7 @@ class DNSCache(object):
         """Returns a list of all entries"""
         def add(x, y): return x+y
         try:
-            return reduce(add, self.cache.values())
+            return reduce(add, list(self.cache.values()))
         except:
             return []
 
@@ -870,7 +872,7 @@ class Engine(threading.Thread):
     def getReaders(self):
         result = []
         self.condition.acquire()
-        result = self.readers.keys()
+        result = list(self.readers.keys())
         self.condition.release()
         return result
     
@@ -1062,7 +1064,7 @@ class ServiceInfo(object):
             for key in properties:
                 value = properties[key]
                 if value is None:
-                    suffix = ''.encode('utf-8')
+                    suffix = b''
                 elif isinstance(value, str):
                     suffix = value.encode('utf-8')
                 elif isinstance(value, int):
@@ -1071,7 +1073,7 @@ class ServiceInfo(object):
                     else:
                         suffix = 'false'
                 else:
-                    suffix = ''.encode('utf-8')
+                    suffix = b''
                 list.append('='.join((key, suffix)))
             for item in list:
                 result = ''.join((result, struct.pack('!c', chr(len(item))), item))
@@ -1540,21 +1542,21 @@ class Zeroconf(object):
 # query (for Zoe), and service unregistration.
 
 if __name__ == '__main__':    
-    print "Multicast DNS Service Discovery for Python, version", __version__
+    print(("Multicast DNS Service Discovery for Python, version", __version__))
     r = Zeroconf()
-    print "1. Testing registration of a service..."
+    print("1. Testing registration of a service...")
     desc = {'version':'0.10','a':'test value', 'b':'another value'}
     info = ServiceInfo("_http._tcp.local.", "My Service Name._http._tcp.local.", socket.inet_aton("127.0.0.1"), 1234, 0, 0, desc)
-    print "   Registering service..."
+    print("   Registering service...")
     r.registerService(info)
-    print "   Registration done."
-    print "2. Testing query of service information..."
-    print "   Getting ZOE service:", str(r.getServiceInfo("_http._tcp.local.", "ZOE._http._tcp.local."))
-    print "   Query done."
-    print "3. Testing query of own service..."
-    print "   Getting self:", str(r.getServiceInfo("_http._tcp.local.", "My Service Name._http._tcp.local."))
-    print "   Query done."
-    print "4. Testing unregister of service information..."
+    print("   Registration done.")
+    print("2. Testing query of service information...")
+    print(("   Getting ZOE service:", str(r.getServiceInfo("_http._tcp.local.", "ZOE._http._tcp.local."))))
+    print("   Query done.")
+    print("3. Testing query of own service...")
+    print(("   Getting self:", str(r.getServiceInfo("_http._tcp.local.", "My Service Name._http._tcp.local."))))
+    print("   Query done.")
+    print("4. Testing unregister of service information...")
     r.unregisterService(info)
-    print "   Unregister done."
+    print("   Unregister done.")
     r.close()
diff --git a/testing/mozbase/mozdevice/mozdevice/__init__.py b/testing/mozbase/mozdevice/mozdevice/__init__.py
index 2493f75db2..5e5b3d9881 100644
--- a/testing/mozbase/mozdevice/mozdevice/__init__.py
+++ b/testing/mozbase/mozdevice/mozdevice/__init__.py
@@ -2,13 +2,13 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from adb import ADBError, ADBRootError, ADBTimeoutError, ADBProcess, ADBCommand, ADBHost, ADBDevice
-from adb_android import ADBAndroid
-from adb_b2g import ADBB2G
-from devicemanager import DeviceManager, DMError, ZeroconfListener
-from devicemanagerADB import DeviceManagerADB
-from devicemanagerSUT import DeviceManagerSUT
-from droid import DroidADB, DroidSUT, DroidConnectByHWID
+from .adb import ADBError, ADBRootError, ADBTimeoutError, ADBProcess, ADBCommand, ADBHost, ADBDevice
+from .adb_android import ADBAndroid
+from .adb_b2g import ADBB2G
+from .devicemanager import DeviceManager, DMError, ZeroconfListener
+from .devicemanagerADB import DeviceManagerADB
+from .devicemanagerSUT import DeviceManagerSUT
+from .droid import DroidADB, DroidSUT, DroidConnectByHWID
 
 __all__ = ['ADBError', 'ADBRootError', 'ADBTimeoutError', 'ADBProcess', 'ADBCommand', 'ADBHost',
            'ADBDevice', 'ADBAndroid', 'ADBB2G', 'DeviceManager', 'DMError', 'ZeroconfListener',
diff --git a/testing/mozbase/mozdevice/mozdevice/adb.py b/testing/mozbase/mozdevice/mozdevice/adb.py
index 5958937d9a..5b9ea58ae0 100644
--- a/testing/mozbase/mozdevice/mozdevice/adb.py
+++ b/testing/mozbase/mozdevice/mozdevice/adb.py
@@ -13,9 +13,10 @@ import traceback
 
 from abc import ABCMeta, abstractmethod
 from distutils import dir_util
+import six
 
 
-class ADBProcess(object):
+class ADBProcess:
     """ADBProcess encapsulates the data related to executing the adb process."""
 
     def __init__(self, args):
@@ -43,7 +44,7 @@ class ADBProcess(object):
         return content
 
     def __str__(self):
-        return ('args: %s, exitcode: %s, stdout: %s' % (
+        return ('args: {}, exitcode: {}, stdout: {}'.format(
             ' '.join(self.args), self.exitcode, self.stdout))
 
 # ADBError, ADBRootError, and ADBTimeoutError are treated
@@ -102,7 +103,7 @@ class ADBTimeoutError(Exception):
     pass
 
 
-class ADBCommand(object):
+class ADBCommand:
     """ADBCommand provides a basic interface to adb commands
     which is used to provide the 'command' methods for the
     classes ADBHost and ADBDevice.
@@ -119,7 +120,7 @@ class ADBCommand(object):
        try:
            adbcommand = ADBCommand()
        except NotImplementedError:
-           print "ADBCommand can not be instantiated."
+           print("ADBCommand can not be instantiated.")
     """
 
     def __init__(self,
@@ -153,7 +154,7 @@ class ADBCommand(object):
         self._polling_interval = 0.1
         self._adb_version = ''
 
-        self._logger.debug("%s: %s" % (self.__class__.__name__,
+        self._logger.debug("{}: {}".format(self.__class__.__name__,
                                        self.__dict__))
 
         # catch early a missing or non executable adb command
@@ -165,7 +166,7 @@ class ADBCommand(object):
             re_version = re.compile(r'Android Debug Bridge version (.*)')
             self._adb_version = re_version.match(output[0]).group(1)
         except Exception as exc:
-            raise ADBError('%s: %s is not executable.' % (exc, adb))
+            raise ADBError('{}: {} is not executable.'.format(exc, adb))
 
     def _get_logger(self, logger_name):
         logger = None
@@ -491,13 +492,12 @@ class ADBHost(ADBCommand):
         return devices
 
 
-class ADBDevice(ADBCommand):
+class ADBDevice(six.with_metaclass(ABCMeta, ADBCommand)):
     """ADBDevice is an abstract base class which provides methods which
     can be used to interact with the associated Android or B2G based
     device. It must be used via one of the concrete implementations in
     :class:`ADBAndroid` or :class:`ADBB2G`.
     """
-    __metaclass__ = ABCMeta
 
     def __init__(self,
                  device=None,
@@ -645,7 +645,7 @@ class ADBDevice(ADBCommand):
         def is_valid_serial(serial):
             return ":" not in serial or serial.startswith("usb:")
 
-        if isinstance(device, (str, unicode)):
+        if isinstance(device, (str, str)):
             # Treat this as a device serial
             if not is_valid_serial(device):
                 raise ValueError("Device serials containing ':' characters are "
@@ -1034,10 +1034,10 @@ class ADBDevice(ADBCommand):
 
         # prepend cwd and env to command if necessary
         if cwd:
-            cmd = "cd %s && %s" % (cwd, cmd)
+            cmd = "cd {} && {}".format(cwd, cmd)
         if env:
-            envstr = '&& '.join(map(lambda x: 'export %s=%s' %
-                                    (x[0], x[1]), env.iteritems()))
+            envstr = '&& '.join(['export %s=%s' %
+                                    (x[0], x[1]) for x in env.items()])
             cmd = envstr + "&& " + cmd
         cmd += "; echo rc=$?"
 
@@ -1160,10 +1160,10 @@ class ADBDevice(ADBCommand):
     # Informational methods
 
     def _get_logcat_buffer_args(self, buffers):
-        valid_buffers = set(['radio', 'main', 'events'])
+        valid_buffers = {'radio', 'main', 'events'}
         invalid_buffers = set(buffers).difference(valid_buffers)
         if invalid_buffers:
-            raise ADBError('Invalid logcat buffers %s not in %s ' % (
+            raise ADBError('Invalid logcat buffers {} not in {} '.format(
                 list(invalid_buffers), list(valid_buffers)))
         args = []
         for b in buffers:
@@ -1436,13 +1436,13 @@ class ADBDevice(ADBCommand):
         self._logger.debug('chmod: path=%s, recursive=%s, mask=%s, root=%s' %
                            (path, recursive, mask, root))
         if not recursive:
-            self.shell_output("chmod %s %s" % (mask, path),
+            self.shell_output("chmod {} {}".format(mask, path),
                               timeout=timeout, root=root)
             return
 
         if self._chmod_R:
             try:
-                self.shell_output("chmod -R %s %s" % (mask, path),
+                self.shell_output("chmod -R {} {}".format(mask, path),
                                   timeout=timeout, root=root)
             except ADBError as e:
                 if e.message.find('No such file or directory') == -1:
@@ -1460,7 +1460,7 @@ class ADBDevice(ADBCommand):
         try:
             tmpf = tempfile.NamedTemporaryFile(delete=False)
             for entry in entries:
-                tmpf.write('chmod %s %s\n' % (mask, entry))
+                tmpf.write('chmod {} {}\n'.format(mask, entry))
             tmpf.close()
             chmodsh = '/data/local/tmp/%s' % os.path.basename(tmpf.name)
             self.push(tmpf.name, chmodsh)
@@ -1560,7 +1560,7 @@ class ADBDevice(ADBCommand):
         data = []
         if self.is_dir(path, timeout=timeout, root=root):
             try:
-                data = self.shell_output("%s %s" % (self._ls, path),
+                data = self.shell_output("{} {}".format(self._ls, path),
                                          timeout=timeout,
                                          root=root).split('\r\n')
                 self._logger.debug('list_files: data: %s' % data)
@@ -1632,7 +1632,7 @@ class ADBDevice(ADBCommand):
                                           root=root)
                 if model == 'Nexus 4':
                     path += '*'
-        lines = self.shell_output('%s %s %s' % (self._ls, recursive_flag, path),
+        lines = self.shell_output('{} {} {}'.format(self._ls, recursive_flag, path),
                                   timeout=timeout,
                                   root=root).split('\r\n')
         for line in lines:
@@ -1647,11 +1647,11 @@ class ADBDevice(ADBCommand):
                 if parent[:-1] in entries:
                     del entries[parent[:-1]]
             elif parent:
-                entry = "%s%s" % (parent, line)
+                entry = "{}{}".format(parent, line)
             else:
                 entry = line
             entries[entry] = 1
-        entry_list = entries.keys()
+        entry_list = list(entries.keys())
         entry_list.sort()
         return entry_list
 
@@ -1841,7 +1841,7 @@ class ADBDevice(ADBCommand):
         if recursive:
             cmd += " -r"
         try:
-            self.shell_output("%s %s" % (cmd, path), timeout=timeout, root=root)
+            self.shell_output("{} {}".format(cmd, path), timeout=timeout, root=root)
             if self.is_file(path, timeout=timeout, root=root):
                 raise ADBError('rm("%s") failed to remove file.' % path)
         except ADBError as e:
@@ -1907,7 +1907,7 @@ class ADBDevice(ADBCommand):
                     pid_i = i
             if user_i == -1 or pid_i == -1:
                 self._logger.error('get_process_list: %s' % header)
-                raise ADBError('get_process_list: Unknown format: %s: %s' % (
+                raise ADBError('get_process_list: Unknown format: {}: {}'.format(
                     header, adb_process))
             ret = []
             line = adb_process.stdout_file.readline()
@@ -1916,9 +1916,9 @@ class ADBDevice(ADBCommand):
                 try:
                     ret.append([int(els[pid_i]), els[-1], els[user_i]])
                 except ValueError:
-                    self._logger.error('get_process_list: %s %s\n%s' % (
+                    self._logger.error('get_process_list: {} {}\n{}'.format(
                         header, line, traceback.format_exc()))
-                    raise ADBError('get_process_list: %s: %s: %s' % (
+                    raise ADBError('get_process_list: {}: {}: {}'.format(
                         header, line, adb_process))
                 line = adb_process.stdout_file.readline()
             self._logger.debug('get_process_list: %s' % ret)
@@ -1962,8 +1962,8 @@ class ADBDevice(ADBCommand):
                 if 'No such process' not in e.message:
                     raise
             pid_set = set(pid_list)
-            current_pid_set = set([str(proc[0]) for proc in
-                                   self.get_process_list(timeout=timeout)])
+            current_pid_set = {str(proc[0]) for proc in
+                                   self.get_process_list(timeout=timeout)}
             pid_list = list(pid_set.intersection(current_pid_set))
             if not pid_list:
                 break
@@ -2033,7 +2033,7 @@ class ADBDevice(ADBCommand):
         :raises: * ADBTimeoutError
                  * ADBError
         """
-        if not isinstance(process_name, basestring):
+        if not isinstance(process_name, str):
             raise ADBError("Process name %s is not a string" % process_name)
 
         # Filter out extra spaces.
@@ -2087,7 +2087,7 @@ class ADBDevice(ADBCommand):
         destination = posixpath.normpath(destination)
         if self._have_cp:
             r = '-R' if recursive else ''
-            self.shell_output('cp %s %s %s' % (r, source, destination),
+            self.shell_output('cp {} {} {}'.format(r, source, destination),
                               timeout=timeout, root=root)
             return
 
@@ -2102,7 +2102,7 @@ class ADBDevice(ADBCommand):
                 # Copy the source file into the destination directory
                 destination = posixpath.join(destination,
                                              posixpath.basename(source))
-            self.shell_output('dd if=%s of=%s' % (source, destination),
+            self.shell_output('dd if={} of={}'.format(source, destination),
                               timeout=timeout, root=root)
             return
 
@@ -2153,7 +2153,7 @@ class ADBDevice(ADBCommand):
         """
         source = posixpath.normpath(source)
         destination = posixpath.normpath(destination)
-        self.shell_output('mv %s %s' % (source, destination), timeout=timeout,
+        self.shell_output('mv {} {}'.format(source, destination), timeout=timeout,
                           root=root)
 
     def reboot(self, timeout=None):
diff --git a/testing/mozbase/mozdevice/mozdevice/adb_android.py b/testing/mozbase/mozdevice/mozdevice/adb_android.py
index bf5fffc0e5..51f4fcd82a 100644
--- a/testing/mozbase/mozdevice/mozdevice/adb_android.py
+++ b/testing/mozbase/mozdevice/mozdevice/adb_android.py
@@ -8,12 +8,13 @@ import time
 
 from abc import ABCMeta
 
-import version_codes
+from . import version_codes
 
-from adb import ADBDevice, ADBError
+from .adb import ADBDevice, ADBError
+import six
 
 
-class ADBAndroid(ADBDevice):
+class ADBAndroid(six.with_metaclass(ABCMeta, ADBDevice)):
     """ADBAndroid implements :class:`ADBDevice` providing Android-specific
     functionality.
 
@@ -22,11 +23,10 @@ class ADBAndroid(ADBDevice):
        from mozdevice import ADBAndroid
 
        adbdevice = ADBAndroid()
-       print adbdevice.list_files("/mnt/sdcard")
+       print(adbdevice.list_files("/mnt/sdcard"))
        if adbdevice.process_exist("org.mozilla.fennec"):
-           print "Fennec is running"
+           print("Fennec is running")
     """
-    __metaclass__ = ABCMeta
 
     def __init__(self,
                  device=None,
@@ -220,7 +220,7 @@ class ADBAndroid(ADBDevice):
                 failure = e.message
 
             if not success:
-                self._logger.debug('Attempt %s of %s device not ready: %s' % (
+                self._logger.debug('Attempt {} of {} device not ready: {}'.format(
                     attempt + 1, self._device_ready_retry_attempts,
                     failure))
                 time.sleep(self._device_ready_retry_wait)
@@ -333,13 +333,13 @@ class ADBAndroid(ADBDevice):
                            "at once")
 
         acmd = ["am", "start"] + \
-            ["-W" if wait else '', "-n", "%s/%s" % (app_name, activity_name)]
+            ["-W" if wait else '', "-n", "{}/{}".format(app_name, activity_name)]
 
         if intent:
             acmd.extend(["-a", intent])
 
         if extras:
-            for (key, val) in extras.iteritems():
+            for (key, val) in extras.items():
                 if isinstance(val, int):
                     extra_type_param = "--ei"
                 elif isinstance(val, bool):
@@ -389,7 +389,7 @@ class ADBAndroid(ADBDevice):
         if moz_env:
             # moz_env is expected to be a dictionary of environment variables:
             # Fennec itself will set them when launched
-            for (env_count, (env_key, env_val)) in enumerate(moz_env.iteritems()):
+            for (env_count, (env_key, env_val)) in enumerate(moz_env.items()):
                 extras["env" + str(env_count)] = env_key + "=" + env_val
 
         # Additional command line arguments that fennec will read and use (e.g.
@@ -465,7 +465,7 @@ class ADBAndroid(ADBDevice):
             data = self.command_output(["uninstall", app_name], timeout=timeout)
             if data.find('Success') == -1:
                 self._logger.debug('uninstall_app failed: %s' % data)
-                raise ADBError("uninstall failed for %s. Got: %s" % (app_name, data))
+                raise ADBError("uninstall failed for {}. Got: {}".format(app_name, data))
             if reboot:
                 self.reboot(timeout=timeout)
 
